BEGIN TRANSACTION;
CREATE TABLE UploadFiles
(
    id   INT GENERATED BY DEFAULT AS IDENTITY,
    name VARCHAR(322),
    data BYTEA NOT NULL
);
CREATE TABLE Locations
(
    id      INT GENERATED BY DEFAULT AS IDENTITY,
    city    VARCHAR(50) NOT NULL UNIQUE,
    country VARCHAR(50) NOT NULL
);
CREATE TABLE Users
(
    id              INT GENERATED BY DEFAULT AS IDENTITY,
    username        VARCHAR(50)  NOT NULL UNIQUE,
    email           VARCHAR(100) NOT NULL UNIQUE,
    hashed_password VARCHAR      NOT NULL,
    avatar_file_id  INT UNIQUE,
    info            VARCHAR(200),
    CONSTRAINT avatar_file_id_fk FOREIGN KEY (avatar_file_id) REFERENCES UploadFiles (id) ON DELETE SET NULL
);
CREATE TABLE Posts
(
    id          INT GENERATED BY DEFAULT AS IDENTITY,
    location_id INT,
    file_id     INT  NOT NULL UNIQUE,
    description VARCHAR(300),
    public_date DATE NOT NULL CHECK (public_date > '2021-01-01'),
    owner_id    INT  NOT NULL,
    CONSTRAINT location_id_fk FOREIGN KEY (location_id) REFERENCES Locations (id),
    CONSTRAINT file_id_fk FOREIGN KEY (file_id) REFERENCES UploadFiles (id),
    CONSTRAINT owner_id_fk FOREIGN KEY (owner_id) REFERENCES Users (id)
);
CREATE TABLE Likes
(
    liker_id INTEGER,
    post_id  INTEGER,
    CONSTRAINT liker_id_post_id_pk PRIMARY KEY (liker_id, post_id),
    CONSTRAINT liker_id_fk FOREIGN KEY (liker_id) REFERENCES Users (id) ON DELETE CASCADE,
    CONSTRAINT post_id_fk FOREIGN KEY (post_id) REFERENCES Posts (id) ON DELETE CASCADE
);
CREATE TABLE Comments
(
    id          INT GENERATED BY DEFAULT AS IDENTITY,
    content     VARCHAR(200) NOT NULL,
    writer_id   INT          NOT NULL,
    post_id     INT          NOT NULL,
    public_date DATE         NOT NULL CHECK (public_date > '2021-01-01'),
    CONSTRAINT writer_id_fk FOREIGN KEY (writer_id) REFERENCES Users (id) ON DELETE CASCADE,
    CONSTRAINT post_id_fk FOREIGN KEY (post_id) REFERENCES Posts (id) ON DELETE CASCADE
);
CREATE TABLE Subscriptions
(
    subscriber_user_id INTEGER,
    tracked_user_id    INTEGER,
    CONSTRAINT subscriber_user_id_tracked_user_id_pk PRIMARY KEY (subscriber_user_id, tracked_user_id),
    CONSTRAINT subscriber_user_id_fk FOREIGN KEY (subscriber_user_id) REFERENCES Users (id) ON DELETE CASCADE,
    CONSTRAINT tracked_user_id_fk FOREIGN KEY (tracked_user_id) REFERENCES Users (id) ON DELETE CASCADE,
    CONSTRAINT subscribe_yourself CHECK (subscriber_user_id != tracked_user_id)
);
CREATE TABLE Stories
(
    id          INT GENERATED BY DEFAULT AS IDENTITY,
    file_id     INT  NOT NULL UNIQUE,
    owner_id    INT  NOT NULL,
    public_date DATE NOT NULL CHECK (public_date > '2021-01-01'),
    CONSTRAINT owner_id_fk FOREIGN KEY (owner_id) REFERENCES Users (id) ON DELETE CASCADE,
    CONSTRAINT file_id_fk FOREIGN KEY (file_id) REFERENCES UploadFiles (id) ON DELETE CASCADE
);
CREATE TABLE StoriesViews
(
    viewer_user_id INTEGER,
    stories_id     INTEGER,
    CONSTRAINT viewed_user_id_stories_id_pk PRIMARY KEY (viewer_user_id, stories_id),
    CONSTRAINT viewed_user_id_fk FOREIGN KEY (viewer_user_id) REFERENCES Users (id) ON DELETE CASCADE,
    CONSTRAINT stories_id_fk FOREIGN KEY (stories_id) REFERENCES Stories (id) ON DELETE CASCADE
);

CREATE INDEX idx_location_city ON Locations USING HASH (city); -- нужен, чтобы при вводе города (когда человек добавляет локацию к посту) получать сразу и соответствующую страну, выбрал hash тк города уникальны
CREATE INDEX idx_username ON Users USING HASH (username); -- чтобы можно было быстро найти пользователя, выбрал hash тк пользователи уникальны
CREATE INDEX idx_post_owner ON Posts (owner_id); -- чтобы можно было, зайдя на страницу человеа, быстро получить все его посты, выбрал b-tree тк у пользователя может быть много постов(owner не уникальный)
CREATE INDEX idx_post_likes ON Likes (post_id); -- чтобы быстро найти все лайки у поста, b-tree тк лайков может быть много
CREATE INDEX idx_subscribers ON Subscriptions (subscriber_user_id); -- чтобы быстро находить всех подписчиков, b-tree тк значения не уникальны
CREATE INDEX idx_subscriptions ON Subscriptions (tracked_user_id); -- чтобы быстро находить все подписки, b-tree тк значения не уникальны
CREATE INDEX idx_stories_viewer ON StoriesViews (stories_id); -- чтобы у истории быстро найти все просмотры, b-tree тк просмотров может быть много

CREATE VIEW users_with_avatars AS
SELECT Users.id,
       username,
       email,
       hashed_password,
       info,
       name,
       data
FROM Users
         LEFT JOIN Uploadfiles ON Users.avatar_file_id = UploadFiles.id;

CREATE VIEW posts_with_image_and_author AS
(
SELECT Posts.id         AS post_id,
       Posts.location_id,
       Posts.description,
       Posts.public_date,
       image.name       AS image_name,
       image.data       AS image_data,
       u.id             AS user_id,
       u.username,
       u.email,
       user_avatar.name AS user_avatar_name,
       user_avatar.data AS user_avatar_data
FROM Posts
         LEFT JOIN Users u ON Posts.owner_id = u.id
         LEFT JOIN Uploadfiles image ON Posts.file_id = image.id
         LEFT JOIN Uploadfiles user_avatar ON u.avatar_file_id = user_avatar.id
    );

CREATE VIEW stories_with_file AS
SELECT Stories.id,
       owner_id,
       public_date,
       name,
       data
FROM Stories
         LEFT JOIN UploadFiles ON Stories.file_id = UploadFiles.id;

CREATE VIEW comments_with_authors AS
SELECT Comments.id AS comment_id,
       content,
       writer_id,
       post_id,
       public_date,
       username,
       email,
       UF.name     AS name_avatar,
       UF.data     AS data_avatar
FROM Comments
         LEFT JOIN Users ON Comments.writer_id = Users.id
         LEFT JOIN UploadFiles UF on Users.avatar_file_id = UF.id;

CREATE MATERIALIZED VIEW avg_number_of_posts_per_user AS
(
WITH count_posts_per_user AS (SELECT COUNT(*) as cnt
                              FROM Users
                                       LEFT JOIN posts p on users.id = p.owner_id
                              where p.id is not null
                              GROUP BY Users.id
)
SELECT SUM(cnt)::real / (SELECT COUNT(*) FROM Users) as value
FROM count_posts_per_user
    );

CREATE MATERIALIZED VIEW proportion_of_posts_with_geolocation_all_users AS
(
SELECT SUM(CASE WHEN location_id IS NOT NULL THEN 1 ELSE 0 END) / COUNT(*)::real AS value
FROM Posts
    );

COMMIT;
